VERSION 5.00
Begin VB.Form frmPaint 
   BackColor       =   &H00E0E0E0&
   Caption         =   "Bild Nr.1"
   ClientHeight    =   2040
   ClientLeft      =   3690
   ClientTop       =   4320
   ClientWidth     =   2280
   FillColor       =   &H00C0C0C0&
   FillStyle       =   7  'Diagonalkreuz
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   Icon            =   "frmPaint.frx":0000
   KeyPreview      =   -1  'True
   MDIChild        =   -1  'True
   ScaleHeight     =   2040
   ScaleWidth      =   2280
   Begin VB.HScrollBar hscHorizontal 
      Height          =   255
      LargeChange     =   5
      Left            =   0
      Max             =   0
      TabIndex        =   3
      Top             =   1800
      Width           =   2055
   End
   Begin VB.VScrollBar vscVertical 
      Height          =   1815
      LargeChange     =   5
      Left            =   2040
      Max             =   0
      TabIndex        =   2
      Top             =   0
      Width           =   255
   End
   Begin VB.PictureBox picScroll 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H00E0E0E0&
      BorderStyle     =   0  'Kein
      FillColor       =   &H00C0C0C0&
      FillStyle       =   7  'Diagonalkreuz
      ForeColor       =   &H00C0C0C0&
      Height          =   2055
      Left            =   0
      ScaleHeight     =   2055
      ScaleWidth      =   2295
      TabIndex        =   0
      Top             =   0
      Width           =   2295
      Begin VB.PictureBox picPicture 
         Appearance      =   0  '2D
         AutoRedraw      =   -1  'True
         AutoSize        =   -1  'True
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'Kein
         ForeColor       =   &H80000008&
         Height          =   495
         Left            =   840
         MouseIcon       =   "frmPaint.frx":0442
         MousePointer    =   99  'Benutzerdefiniert
         ScaleHeight     =   33
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   33
         TabIndex        =   1
         Top             =   720
         Width           =   495
         Begin VB.Line linEffect 
            BorderColor     =   &H0000FF00&
            Visible         =   0   'False
            X1              =   0
            X2              =   0
            Y1              =   0
            Y2              =   32
         End
         Begin VB.Shape shpArea 
            BorderStyle     =   3  'Punkt
            DrawMode        =   6  'Stift und inverse Anzeige maskieren
            Height          =   255
            Left            =   120
            Top             =   120
            Visible         =   0   'False
            Width           =   255
         End
      End
   End
End
Attribute VB_Name = "frmPaint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Maussteuerung mit der Tastatur
    Private Declare Function GetCursorPos Lib "User32" (lpPoint As POINTAPI) As Long
    Private Declare Sub mouse_event Lib "User32" (ByVal dwFlags As Long, ByVal dx As Long, ByVal dy As Long, ByVal cbuttons As Long, ByVal dwExtraInfo As Long)
    Private Declare Function SetCursorPos Lib "User32" (ByVal X As Long, ByVal Y As Long) As Long
        'Um den Cusor zu zentrieren
            Private Declare Function GetWindowRect Lib "User32" (ByVal hwnd As Long, RECT As RECT) As Long
        '/Um den Cursor zu zentrieren
    Private Const MOUSEEVENTF_LEFTDOWN = &H2
    Private Const MOUSEEVENTF_LEFTUP = &H4
    Private Const MOUSEEVENTF_RIGHTDOWN = &H8
    Private Const MOUSEEVENTF_RIGHTUP = &H10
        Private Enum MouseButtons
            LeftMouseButton
            RightMouseButton
        End Enum
'/Maussteuerung mit der Tastatur

Dim blnKeyDown As Boolean
Dim blnMouseModus As Boolean
Dim intLeft, intTop As Integer 'Die Mauskoordinaten
Dim intMouseLeft, intMouseTop As Integer
Dim intStartX, intStartY, intOldX, intOldY As Integer
Dim typPOINTAPI_Dim As POINTAPI 'Decl. schon in Modul


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    Select Case Shift And 7
        Case 7
            blnMouseModus = True
    End Select
    
    Select Case KeyCode
        Case vbKeySpace
            MouseDown LeftMouseButton
        Case vbKeyNumpad1
            intLeft = intLeft - 1: intTop = intTop + 1
            SetCursorPos intLeft, intTop
        Case vbKeyNumpad2
            intTop = intTop + 1
            SetCursorPos intLeft, intTop
        Case vbKeyNumpad3
            intLeft = intLeft + 1: intTop = intTop + 1
            SetCursorPos intLeft, intTop
        Case vbKeyNumpad4
            intLeft = intLeft - 1
            SetCursorPos intLeft, intTop
        Case vbKeyNumpad6
            intLeft = intLeft + 1
            SetCursorPos intLeft, intTop
        Case vbKeyNumpad7
            intLeft = intLeft - 1: intTop = intTop - 1
            SetCursorPos intLeft, intTop
        Case vbKeyNumpad8
            intTop = intTop - 1
            SetCursorPos intLeft, intTop
        Case vbKeyNumpad9
            intLeft = intLeft + 1: intTop = intTop - 1
            SetCursorPos intLeft, intTop
    End Select

End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)

    If KeyAscii = 27 Then '27 = ESC
        blnESC = True
    End If

    If blnMouseDown = True Then Exit Sub

End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    
    If KeyCode = vbKeySpace Then MouseUp LeftMouseButton
    
    blnESC = False
    blnKeyDown = False
    blnMouseModus = False

End Sub

Private Sub Form_Load()

    blnMouseDown = False
    intAreaX1 = 0: intAreaX2 = 0
    intAreaY1 = 0: intAreaY1 = 0

On Error Resume Next
                    
    Select Case bytPaintNumber
        Case 1
        Case 2
        Case 3
        Case 4
        Case 5
        Case 6
        Case 7
        Case 8
        Case 9
        Case 10
        Case 11
        Case 12
        Case 13
    End Select

    intAreaX1 = 0: intAreaX2 = picPicture.ScaleWidth
    intAreaY1 = 0: intAreaY2 = picPicture.ScaleHeight

    Call SetScrolls

    Form_Resize 'Raster wird gezeichnet

        mdiMain.mnuWindows(0).Visible = True
        mdiMain.mnuWindows(0).Caption = Me.Caption

End Sub

Private Sub Form_Paint()

    Form_Resize

End Sub

Private Sub Form_Resize()

    On Error Resume Next

    Call SetScrolls
    Call CenterPic

    With picScroll
        .Width = vscVertical.Left
        .Height = hscHorizontal.Top
    End With
    
    picScroll.Cls
    picScroll.Line (0, 0)-(picScroll.Width, picScroll.Height), , B
    
    Call SetScrolls

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Dim bytSave As Byte

    If typPicInfo(Format(Right(Me.Caption, 3), "000")).blnChanged = True Then
        bytSave = MsgBox("Das Bild wurde gendert, soll es jetzt gespeichert werden ?", vbQuestion + vbYesNoCancel, "Speichern:")
            If bytSave = vbYes Then
                mdiMain.mnuSaveFile_Click 'Das Bild wird gespeichert
            ElseIf bytSave = vbNo Then 'Nichts, denn wir sind hier im Unload -Sub
            Else
                Cancel = 1
                    Exit Sub
            End If
    End If
    
    intRealPicCount = intRealPicCount - 1
    
    If intRealPicCount = 0 Then
        With mdiMain
            .mnuPicture.Enabled = False
            .mnuWindow.Enabled = False
            .mnuColors.Enabled = False
            .mnuView.Enabled = False
        End With
    End If
        
End Sub

Private Sub picPicture_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

On Error GoTo errError

    If typINIValue.bytCapMouse = 0 Then GoTo nxtNext

    Dim typRect As RECT
    Dim typPoint As POINTAPI
    
    Call GetClientRect(picPicture.hwnd, typRect)

    typPoint.X = typRect.Left
    typPoint.Y = typRect.Top
    
    Call ClientToScreen(picPicture.hwnd, typPoint)
    Call OffsetRect(typRect, typPoint.X, typPoint.Y)
    Call ClipCursor(typRect)

nxtNext:

    If blnKeyDown Then Exit Sub

    With picPicture
        .DrawMode = 13
    
        intStartX = X: intStartY = Y
        intOldX = X: intOldY = Y
        blnMouseDown = True
    
        Dim lnghBrush, lngColor As Long
    
            typPicInfo(Format(Right(Me.Caption, 3), "000")).blnChanged = True
            
            Select Case bytPaintNumber
                Case 2
                    Exit Sub
                Case 3
                    Exit Sub
                Case 4
                    .Refresh
                    .DrawMode = 6
                    .DrawStyle = 2
                Case 5
                    .DrawWidth = intBrushWidth 'Die Linienstrke wird gesetzt
                        If Button = vbLeftButton Then
                            picPicture.PSet (X, Y), mdiMain.picColor(0).BackColor
                        ElseIf Button = vbRightButton Then
                            picPicture.PSet (X, Y), mdiMain.picColor(1).BackColor
                        End If
                Case 6
                    Exit Sub
                Case 7
                    Exit Sub
                Case 8
                        If Button = vbLeftButton Then
                            mdiMain.picColor(0).BackColor = .Point(X, Y)
                            mdiMain.SetColorValues mdiMain.picChooseColor(0).BackColor
                        ElseIf Button = vbRightButton Then
                            mdiMain.picColor(1).BackColor = .Point(X, Y)
                            mdiMain.SetColorValues mdiMain.picChooseColor(1).BackColor
                        End If
                Case 9
                    If Button = vbLeftButton Then
                        lnghBrush = CreateSolidBrush(CLng(mdiMain.picColor(0).BackColor)) 'Die Farbe wird betimmt
                              Call SelectObject(.hdc, lnghBrush) 'Das Object wird bestimmt
                              lngColor = GetPixel(.hdc, X, Y) 'Welche Farbe wird ersetzt
                              Call ExtFloodFill(.hdc, X, Y, lngColor, FLOODFILLSURFACE) 'Das Feld wird aufgefllt
                              Call DeleteObject(lnghBrush) 'Das erstellte Objekt wird gelscht
                    ElseIf Button = vbRightButton Then
                        lnghBrush = CreateSolidBrush(CLng(mdiMain.picColor(1).BackColor)) 'Die Farbe wird betimmt
                              Call SelectObject(.hdc, lnghBrush) 'Das Object wird bestimmt
                              lngColor = GetPixel(.hdc, X, Y) 'Welche Farbe wird ersetzt
                              Call ExtFloodFill(.hdc, X, Y, lngColor, FLOODFILLSURFACE) 'Das Feld wird aufgefllt
                              Call DeleteObject(lnghBrush) 'Das erstellte Objekt wird gelscht
                    End If
                Case 10
                    If Button = vbLeftButton Then
                        .ForeColor = mdiMain.picColor(0).BackColor
                        .FillColor = picPicture.ForeColor
                    ElseIf Button = vbRightButton Then
                        .ForeColor = mdiMain.picColor(1).BackColor
                        .FillColor = picPicture.ForeColor
                    End If
                        .DrawMode = 6
                        .DrawWidth = 1
                            If blnShapeStyle Then
                                .FillStyle = 1
                            Else
                                .FillStyle = 0
                            End If
                Case 11
                    .DrawWidth = frmProperties.txtLineSize.Text
                    .DrawMode = 6
                Case 12
                    If Button = vbLeftButton Then
                        If blnMouseDown Then DrawSpray X, Y, intSpraySteps, bytSprayRadius, mdiMain.picColor(0).BackColor
                    ElseIf Button = vbRightButton Then
                        If blnMouseDown Then DrawSpray X, Y, intSpraySteps, bytSprayRadius, mdiMain.picColor(1).BackColor
                    End If
                Case 13
                    Exit Sub
            End Select
    
            .Refresh 'Das Bild wird aktualisiert
    End With
            
            If Button = vbRightButton Then 'Wenn die Maus ber dem Rechteck ist und sie gedrckt wird, verschwindet es.
                If X >= shpArea.Left And X <= shpArea.Left + shpArea.Width And Y >= shpArea.Top And Y <= shpArea.Top + shpArea.Height Then
                    If shpArea.Visible = True Then shpArea.Visible = False
                    mdiMain.mnuCopy.Enabled = False
                End If
                    intAreaX1 = 0: intAreaX2 = picPicture.ScaleWidth
                    intAreaY1 = 0: intAreaY2 = picPicture.ScaleHeight
            End If
      
        Exit Sub
        
errError:
    Call ClipCursor(ByVal 0)
      
End Sub

Private Sub picPicture_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    If blnKeyDown Then Exit Sub

    On Error Resume Next
    
    Call StatusText("Koordinaten: X=" & X & " : Y=" & Y)

    Select Case bytPaintNumber
        Case 2
            Exit Sub
        Case 3
            Exit Sub
        Case 4
            If Button = vbLeftButton Then
                picPicture.Line (intStartX, intStartY)-(X, Y), , B
                picPicture.Line (intStartX, intStartY)-(intOldX, intOldY), , B
                intOldX = X
                intOldY = Y
            End If
        Case 5
            If Button = vbLeftButton Then
                picPicture.PSet (X, Y), mdiMain.picColor(0).BackColor
                picPicture.Line (X, Y)-(intOldX, intOldY), mdiMain.picColor(0).BackColor
            ElseIf Button = vbRightButton Then
                picPicture.PSet (X, Y), mdiMain.picColor(1).BackColor
                picPicture.Line (X, Y)-(intOldX, intOldY), mdiMain.picColor(1).BackColor
            End If
                intOldX = X: intOldY = Y
        Case 6
            Exit Sub
        Case 7
            Exit Sub
        Case 8
            If Button = vbLeftButton Then
                mdiMain.picColor(0).BackColor = picPicture.Point(X, Y)
            ElseIf Button = vbRightButton Then
                mdiMain.picColor(1).BackColor = picPicture.Point(X, Y)
            End If
                If blnMouseDown Then mdiMain.SetColorValues picPicture.Point(X, Y)
        Case 9
            Exit Sub
        Case 10
                Select Case bytSubPaintNumber
                    Case 1
                        If blnMouseDown = True Then
                            Ellipse picPicture.hdc, intStartX, intStartY, intOldX, intOldY
                            Ellipse picPicture.hdc, intStartX, intStartY, X, Y
                                intOldX = X: intOldY = Y
                        End If
                    Case 2
                    Case 3
                        If blnMouseDown Then
                            If X > Y Then
                                Rectangle picPicture.hdc, intStartX, intStartY, intOldX, intOldY
                                Rectangle picPicture.hdc, intStartX, intStartY, Y, Y
                                intOldX = Y: intOldY = Y
                            Else
                                Rectangle picPicture.hdc, intStartX, intStartY, intOldX, intOldY
                                Rectangle picPicture.hdc, intStartX, intStartY, X, X
                                intOldX = X: intOldY = X
                            End If
                        End If
                    Case 4
                    Case 5
                        If blnMouseDown Then
                            Rectangle picPicture.hdc, intStartX, intStartY, intOldX, intOldY
                            Rectangle picPicture.hdc, intStartX, intStartY, X, Y
                                intOldX = X: intOldY = Y
                        End If
                    Case 6
                        If Button = vbLeftButton Then
                            picPicture.ForeColor = mdiMain.picColor(0).BackColor
                        ElseIf Button = vbRightButton Then
                            picPicture.ForeColor = mdiMain.picColor(1).BackColor
                        End If
                            If blnMouseDown Then
                                RoundRect picPicture.hdc, intStartX, intStartY, intOldX, intOldY, intRoundWidth, intRoundWidth
                                RoundRect picPicture.hdc, intStartX, intStartY, X, Y, intRoundWidth, intRoundWidth
                                    intOldX = X: intOldY = Y
                            End If
                End Select
            intOldX = X: intOldY = Y
            picPicture.Refresh
        Case 11
            If blnMouseDown Then
                picPicture.Line (intStartX, intStartY)-(X, Y)
                picPicture.Line (intStartX, intStartY)-(intOldX, intOldY)
                intOldX = X
                intOldY = Y
            End If
        Case 12
            If Button = vbLeftButton Then
                If blnMouseDown Then DrawSpray X, Y, intSpraySteps, bytSprayRadius, mdiMain.picColor(0).BackColor
            ElseIf Button = vbRightButton Then
                If blnMouseDown Then DrawSpray X, Y, intSpraySteps, bytSprayRadius, mdiMain.picColor(1).BackColor
            End If
        Case 13
            Exit Sub
    End Select

End Sub

Private Sub picPicture_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Call ClipCursor(ByVal 0)

    If blnKeyDown Then Exit Sub

        blnMouseDown = False
    
    With picPicture
        Select Case bytPaintNumber
            Case 2
                Exit Sub
            Case 3
                Exit Sub
            Case 4
                picPicture.Line (intStartX, intStartY)-(intOldX, intOldY), , B
                .DrawStyle = 0
                intAreaX1 = intStartX: intAreaX2 = intOldX 'Area Daten
                intAreaY1 = intStartY: intAreaY2 = intOldY 'Area Daten
                Exchange
                mdiMain.mnuCopy.Enabled = True
            Case 5
                Exit Sub
            Case 6
                Exit Sub
            Case 7
                Exit Sub
            Case 8
                mdiMain.SetColorValues mdiMain.picColor(0).BackColor
            Case 9
                Exit Sub
            Case 10
                .DrawMode = 13
                    Select Case bytSubPaintNumber
                        Case 1
                            Ellipse .hdc, intStartX, intStartY, X, Y
                        Case 2
                        Case 3
                        Case 4
                        Case 5
                            Rectangle .hdc, intStartX, intStartY, X, Y
                        Case 6
                            RoundRect .hdc, intStartX, intStartY, X, Y, intRoundWidth, intRoundWidth
                    End Select
                            .Refresh
            Case 11
                .DrawMode = 13
                picPicture.Line (intStartX, intStartY)-(X, Y), mdiMain.picColor(0).BackColor
            Case 12
                Exit Sub
            Case 13
                Exit Sub
        End Select
    
        .DrawMode = 13 'Die alten Grafikoperationen werden wider hergestellt
        .DrawStyle = 0
    End With

End Sub

Private Function Exchange() 'Die AREA Variablen werden geordnet

Dim intTempX, intTempY As Integer 'Temporrer Speicher
            
            If intAreaX1 > intAreaX2 Then
                If intAreaY1 > intAreaY2 Then
                    intTempX = intAreaX1
                    intTempY = intAreaY1
                    
                    intAreaX1 = intAreaX2: intAreaX2 = intTempX
                    intAreaY1 = intAreaY2: intAreaY2 = intTempY
                Else
                    intTempX = intAreaX1
                    
                    intAreaX1 = intAreaX2: intAreaX2 = intTempX
                End If
            Else
                If intAreaY1 > intAreaY2 Then
                    intTempY = intAreaY1

                    intAreaY1 = intAreaY2: intAreaY2 = intTempY
                End If
            End If
            
            With shpArea
                .Visible = True
                .Left = intAreaX1
                .Top = intAreaY1
                .Width = intAreaX2 - .Left
                .Height = intAreaY2 - .Top
            End With
            
End Function

Private Sub hscHorizontal_Change()

    picPicture.Move -hscHorizontal.Value * Screen.TwipsPerPixelX, picPicture.Top

End Sub

Private Sub hscHorizontal_Scroll()

    hscHorizontal_Change

End Sub

Private Sub picPicture_Resize()

    CenterPic
    SetScrolls

End Sub

Private Sub picScroll_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Call StatusText("")

End Sub

Private Sub vscVertical_Change()

    picPicture.Move picPicture.Left, -vscVertical.Value * Screen.TwipsPerPixelY

End Sub

Private Sub vscVertical_Scroll()

    vscVertical_Change

End Sub

Public Sub SetScrolls()
    
    On Error Resume Next

    hscHorizontal.Max = (picPicture.Width - picScroll.Width) / Screen.TwipsPerPixelX
    vscVertical.Max = (picPicture.Height - picScroll.Height) / Screen.TwipsPerPixelY

    With vscVertical
        .Height = Me.Height - (43 * Screen.TwipsPerPixelY)
        .Left = Me.Width - (24 * Screen.TwipsPerPixelX)
            If picPicture.Height > picScroll.Height Then
                .Value = -picPicture.Top / Screen.TwipsPerPixelY
            Else
                .Max = 0
                .Value = 0
            End If
    End With

    With hscHorizontal
        .Width = vscVertical.Left
        .Top = Me.Height - (43 * Screen.TwipsPerPixelY)
            If picPicture.Width > picScroll.Width Then
                .Value = -picPicture.Left / Screen.TwipsPerPixelX
            Else
                .Max = 0
                .Value = 0
            End If
    End With

End Sub

Public Sub CenterPic()

    picPicture.Move (picScroll.Width - picPicture.Width) / 2, (picScroll.Height - picPicture.Height) / 2

End Sub

Private Function DrawSpray(ByVal X As Integer, ByVal Y As Integer, ByVal bytSteps As Byte, ByVal bytRadius As Byte, ByVal lngColor As Long)

    Dim bytCount As Byte
    
    For bytCount = 0 To bytSteps
        SetPixel picPicture.hdc, X - (Sin(bytCount) * Rnd(360)) * bytRadius, Y - (Cos(bytCount) * Rnd(360)) * bytRadius, lngColor
    Next
    
    picPicture.Refresh

End Function

Private Sub CenterCursor(varObject As Control)

    Dim typRECT_Dim As RECT
    
    GetWindowRect varObject.hwnd, typRECT_Dim
    SetCursorPos typRECT_Dim.Left + (typRECT_Dim.Right - typRECT_Dim.Left) / 2, typRECT_Dim.Top + (typRECT_Dim.Bottom - typRECT_Dim.Top) / 2
    
End Sub

Private Sub MouseUp(MouseButton As MouseButtons)

   Select Case (MouseButton)
      Case LeftMouseButton
         Call mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0)
      Case RightMouseButton
         Call mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0)
   End Select
   
End Sub

Private Sub MouseDown(MouseButton As MouseButtons)

   Select Case (MouseButton)
      Case LeftMouseButton
         Call mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0)
      Case RightMouseButton
         Call mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0)
   End Select
   
End Sub

Private Sub MouseClick(MouseButton As MouseButtons)

    MouseDown (MouseButton)
    MouseUp (MouseButton)
    
End Sub
